# [Rust Module of the Week](https://motw.rs)
A weekly dive into commonly used modules in the Rust ecosystem, with story flavor!

### Build status

* Release
    - [![Rust examples](https://github.com/slyons/rust-module-of-the-week/actions/workflows/rust.yml/badge.svg?branch=main)](https://github.com/slyons/rust-module-of-the-week/actions/workflows/rust.yml)
    - [![Content](https://github.com/slyons/rust-module-of-the-week/actions/workflows/publish.yml/badge.svg?branch=main)](https://github.com/slyons/rust-module-of-the-week/actions/workflows/publish.yml)
* Draft
    - [![Rust examples](https://github.com/slyons/rust-module-of-the-week/actions/workflows/rust.yml/badge.svg?branch=draft)](https://github.com/slyons/rust-module-of-the-week/actions/workflows/rust.yml)
    - [![Content](https://github.com/slyons/rust-module-of-the-week/actions/workflows/draftcheck.yml/badge.svg?branch=draft)](https://github.com/slyons/rust-module-of-the-week/actions/workflows/draftcheck.yml)

## The goal

The goal of this project is to bring the same concept as [PyMOTW](https://pymotw.com/3/) to the Rust world. PyMOTW was an invaluable resource for me when I was learning Python years ago, and I hope that I can help someone in a similar way. Each week we'll dive into a module and explore some of the functionality that we can find there while following along the adventures of some colourful characters.

## Why the story?

I have always found that I learn better when there's a story behind something I'm learning, a purpose. I've looked at my fair share of documentation but I've found that a lot of code samples can be hard to follow without broader context. So I've decided that every issue will include the story of one or more characters and their problems that only Rust can solve.

## Examples

See the [examples README](./rmotw/README.md) for how to run them.

## Contributing

Feel free to fork and open Pull Requests about any past or potential future content! I would especially welcome any code feedbacks as I'm sure there'll be lots of chances to improve my code. A proper development guide is planned.